﻿Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=1.70
@EndOfDesignText@
#Region Module Attributes
	'This works on the MotoX but not on the Wiko:
	#StartAtBoot: False
#End Region

'Service module
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	
	'Declares the phone state listener
	Dim PSL As PhoneStateListener

End Sub

Sub Service_Create

	wmUtils.wmDebugLogWrite("Listener service created")

	' Service.AutomaticForegroundMode always shows a notification.
	' The default one includes sound and vibrate.
	' Each time the service is started, this notification is shown.
	' Create our own notification without sound or vibrate.
	' Based on https://www.b4x.com/android/forum/threads/solved-nb6-notification-with-foreground-service.102372/#post-642469
	Dim n As NB6
	n.Initialize("default", Application.LabelName, "LOW", True).AutoCancel(False).SmallIcon(Starter.notifIcon).SetDefaults(False, False, False).CustomVibrate(Array As Long(0,0))
	Dim noti As Notification = n.Build(Application.LabelName, "Is active", "", Main)
	Service.AutomaticForegroundNotification = noti
	Service.AutomaticForegroundMode = Service.AUTOMATIC_FOREGROUND_ALWAYS

	'Initializes the PhoneStateListener.
	'All data is also outputted to the filtered log field.
	PSL.Initialize("PSL", True)
	
	'Starts listening
	PSL.startListeningForEvent(PSL.LISTEN_SERVICE_STATE)
	
	'Remember: Find all information about the returns here:
	' http://developer.android.com/reference/android/telephony/PhoneStateListener.html

End Sub

Sub Service_Start (StartingIntent As Intent)

	wmUtils.wmDebugLogWrite("Listener service started")

End Sub

Sub StopListener

	PSL.stopListening
	Service.StopAutomaticForeground
	StopService(Me)	

End Sub

Sub Service_Destroy

End Sub

' Callback invoked when the call-forwarding indicator changes.
Sub PSL_onCallForwardingIndicatorChanged(cfi As Boolean)
End Sub

'Callback invoked when device call state changes.
'Idle = 0
'Ringing = 1
'OFFHook = 2
Sub PSL_onCallStateChanged (State As Int, incomingNumber As String)
End Sub

' Callback invoked when device cell location changes.
Sub PSL_onCellLocationChanged(Location As String)
End Sub

'Callback invoked when data activity state changes.
Sub PSL_onDataActivity(Direction As Int, strDirection As String)
End Sub

'Callback invoked when connection state changes.
Sub PSL_onDataConnectionStateChanged(state As Int, Connectionstate As String)
End Sub

'Callback invoked when the message-waiting indicator changes.
Sub PSL_onMessageWaitingIndicatorChanged(mwi As Boolean)
End Sub

'Callback invoked when device service state changes.
Sub PSL_onServiceStateChanged(State As Int, strState As String)

	If State = 0 Then ' STATE_IN_SERVICE - see https://developer.android.com/reference/android/telephony/PhoneStateListener.html#onServiceStateChanged(android.telephony.ServiceState)
		If Starter.connectedToGSMnetwork = False Then
			Starter.connectedToGSMnetwork = True
			CallSubDelayed3(Main, "AddToCLvBlack", "PanicPuck is connected to the phone network", True)
		End If
	Else
		If Starter.connectedToGSMnetwork Then
			Starter.connectedToGSMnetwork = False
			CallSubDelayed3(Main, "AddToCLvRed", "PanicPuck is disconnected from the phone network", True)
		End If
	End If

End Sub

'Callback invoked when network signal strengths changes.
'you can use getCDma, etc to get the network connection.
Sub PSL_onSignalStrengthsChanged (signalStrength As String)
End Sub

'Remember: Find all information about the returns here:
' http://developer.android.com/reference/android/telephony/PhoneStateListener.html