﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=5.2
@EndOfDesignText@
'From: https://www.b4x.com/android/forum/threads/one-sms-module-all-inclusive.58782/
'Modified by WM - see 'WM' in the code below

'Add to Manifest :
'AddPermission(android.permission.RECEIVE_SMS)
'AddPermission(android.permission.SEND_SMS)
'AddReceiverText(oneSms,
'<intent-filter>
'		<action android:name="android.provider.Telephony.SMS_RECEIVED"/>
'</intent-filter>)
'
'Functions:
'Initialize(Owner as object)
'SendSms(Msg as typeSmsMessage)
'
'Events :
'Sub oneSms_SmsReceived(Number as String, Text as string)
'Sub oneSms_SendResult(Result as typeSmsResult)

#Region  Service Attributes 
	#StartAtBoot: False
	#StartCommandReturnValue: android.app.Service.START_STICKY
#End Region

Private Sub Process_Globals
	Type typeSmsMessage (Number As String, Text As String, MsgID As String, SentReport As Boolean, DeliveryReport As Boolean)
	Type typeSmsResult (Success As Boolean, Number As String, Result As String, ResultText As String, MsgID As String) ' WM : added 'Success'

	Private mOwner As Object 
	Private PE As PhoneEvents
	Private NativeMe As JavaObject
	Private SentResults As List
	Private DeliveredResults As List
End Sub

Private Sub Service_Create
	SentResults.Initialize
	DeliveredResults.Initialize
	PE.Initialize("PE")
End Sub

Private Sub Service_Start (StartingIntent As Intent)

	If Starter.handleReceivedSMSs = False Then Return ' WM

	Try ' WM
		If StartingIntent.Action.ToUpperCase = "ANDROID.PROVIDER.TELEPHONY.SMS_RECEIVED" Then
			Dim messages As List
			messages = ParseSmsIntent(StartingIntent)
			For i = 0 To messages.Size - 1
				Dim Msg As typeSmsMessage = messages.Get(i)
				If SubExists(mOwner, "oneSms_SmsReceived") Then
					CallSubDelayed3(mOwner, "oneSms_SmsReceived", Msg.Number, Msg.Text)
				End If
			Next
		End If
	Catch
		Log("oneSMS: " & LastException)
	End Try
End Sub

Private Sub Service_Destroy
End Sub

Public Sub Initialize(Owner As Object)
	mOwner = Owner
End Sub

Public Sub SendSMS(Msg As typeSmsMessage)
	If Msg.Number.Length > 0 And Msg.Text.Length > 0 Then
		Dim Extra As Map
		Extra.Initialize
		Extra.Put("message_id", Msg.MsgID)
		Dim Tim As String = DateTime.Now
		Extra.Put("message_time", Tim)
		NativeMe=Me 
		NativeMe.RunMethod("Send3", Array(Msg.Number, Msg.Text, Extra, Msg.SentReport, Msg.DeliveryReport))
	End If
End Sub

Private Sub PE_SmsDelivered (PhoneNumber As String, Intent As Intent)
	If IsDeliveredReported(Intent.GetExtra("message_time")) = False Then
		Dim Res As typeSmsResult
		Res.Success = True ' WM : added this
		Res.Number = PhoneNumber
		Res.Result = "DELIVERED"
		Res.ResultText = "OK"
		Res.MsgID = Intent.GetExtra("message_id")
		If SubExists(mOwner, "oneSms_SendResult") Then
			CallSubDelayed2(mOwner, "oneSms_SendResult", Res)
		End If
	End If
End Sub

Private Sub PE_SmsSentStatus (Success As Boolean, ErrorMessage As String, PhoneNumber As String, Intent As Intent)
	If IsSentReported(Intent.GetExtra("message_time")) = False Then
		Dim Res As typeSmsResult
		Res.Success = Success ' WM : added this
		Res.Number = PhoneNumber
		Res.Result = "SENT"
		Res.ResultText = ErrorMessage
		Res.MsgID = Intent.GetExtra("message_id")
		If SubExists(mOwner, "oneSms_SendResult") Then
			CallSubDelayed2(mOwner, "oneSms_SendResult", Res)
		End If
	End If
End Sub

Private Sub IsSentReported(msg_time As Long) As Boolean
	Dim idx As Int = SentResults.IndexOf(msg_time)
	For count = SentResults.Size -1 To 0 Step -1
		If SentResults.Get(count) < DateTime.Now - DateTime.TicksPerHour Then
			SentResults.RemoveAt(count)
		End If
	Next
	If idx < 0 Then
		SentResults.Add(msg_time)
		Return False
	Else
		Return True
	End If
End Sub

Private Sub IsDeliveredReported(msg_time As Long) As Boolean
	Dim idx As Int = DeliveredResults.IndexOf(msg_time)
	For count = DeliveredResults.Size -1 To 0 Step -1
		If DeliveredResults.Get(count) < DateTime.Now - DateTime.TicksPerDay Then
			DeliveredResults.RemoveAt(count)
		End If
	Next
	If idx < 0 Then
		DeliveredResults.Add(msg_time)
		Return False
	Else
		Return True
	End If
End Sub

'Parses an SMS intent and returns an array of messages
Private Sub ParseSmsIntent (In As Intent) As List
    Dim messages_list As List
    messages_list.Initialize
    If In.HasExtra("pdus") = False Then Return messages_list
    Dim pdus() As Object
    Dim r As Reflector
    pdus = In.GetExtra("pdus")
    Dim messagesMap As Map
    messagesMap.Initialize
    If pdus.Length > 0 Then
        For i = 0 To pdus.Length - 1
            Dim Msg As typeSmsMessage
            r.Target = r.RunStaticMethod("android.telephony.SmsMessage", "createFromPdu", Array As Object(pdus(i)), Array As String("[B"))
            Msg.Text = r.RunMethod("getMessageBody")
            Msg.Number = r.RunMethod("getOriginatingAddress")
            If messagesMap.ContainsKey(Msg.Number) Then
                Dim existing As typeSmsMessage
                existing = messagesMap.Get(Msg.Number)
                existing.Text = existing.text & Msg.Text
            Else
                messagesMap.Put(Msg.number, Msg)
                messages_list.Add(Msg)
            End If
        Next
    End If
    Return messages_list
End Sub

#If JAVA

import java.util.Random;
import java.util.ArrayList;
import java.util.Map;
import android.content.Context;
import android.content.Intent;
import android.app.PendingIntent;
import android.telephony.SmsManager;

public static void Send3(String PhoneNumber, String Text, Map<String, String> Extra, boolean ReceiveSentNotification, boolean ReceiveDeliveredNotification) {
    SmsManager sm = SmsManager.getDefault();

    /* Generate a unique requestCode for each Intent */
    Random randomNo = new Random();
    int requestCode = (int)(System.currentTimeMillis()/1000) + randomNo.nextInt(1000);

    Intent mSendIntent = new Intent("b4a.smssent");
    mSendIntent.putExtra("phone", PhoneNumber);

    // Add additional Extra Data
    for (Map.Entry<String, String> entry : Extra.entrySet()) {
        mSendIntent.putExtra(entry.getKey(), entry.getValue());
    }
    PendingIntent sentIntent = ReceiveSentNotification ? PendingIntent.getBroadcast(BA.applicationContext, requestCode, mSendIntent, PendingIntent.FLAG_UPDATE_CURRENT) : null;

    Intent mDeliveryIntent = new Intent("b4a.smsdelivered");
    mDeliveryIntent.putExtra("phone", PhoneNumber);

    // Add additional Extra Data
    for (Map.Entry<String, String> entry : Extra.entrySet()) {
        mDeliveryIntent.putExtra(entry.getKey(), entry.getValue());
    }
    PendingIntent deliveryIntent = ReceiveDeliveredNotification ? PendingIntent.getBroadcast(BA.applicationContext, requestCode, mDeliveryIntent, PendingIntent.FLAG_UPDATE_CURRENT) : null;

// WM : changed 160 to 70 here:
    if (Text.length() > 70) {
        ArrayList<String> parts = sm.divideMessage(Text);
        int numParts = parts.size();
        ArrayList<PendingIntent> sentIntents = new ArrayList<PendingIntent>();
        ArrayList<PendingIntent> deliveryIntents = new ArrayList<PendingIntent>();
        for (int i = 0; i < numParts; i++) {
            if (ReceiveSentNotification) {
                sentIntents.add(PendingIntent.getBroadcast(BA.applicationContext, requestCode, mSendIntent, PendingIntent.FLAG_UPDATE_CURRENT));
            }
            if (ReceiveDeliveredNotification) {
                deliveryIntents.add(PendingIntent.getBroadcast(BA.applicationContext, requestCode, mDeliveryIntent, PendingIntent.FLAG_UPDATE_CURRENT));
            }
        }
        sm.sendMultipartTextMessage(PhoneNumber, null, parts, ReceiveSentNotification ? sentIntents : null, ReceiveDeliveredNotification ? deliveryIntents : null);
    }
    else {
        sm.sendTextMessage(PhoneNumber, null, Text, sentIntent, deliveryIntent);
    }
}

#End If